mod bst;
mod stack;

use bst::BinarySearchTree;
use stack::Stack;

struct Greeter {
    greeting: &'static str,
}

impl Greeter {
    fn new(greeting: &'static str) -> Greeter {
        Greeter { greeting }
    }

    fn greet(&self) {
        println!("{}", self.greeting);
    }
}

fn main() {
    Greeter::new("Hello, Jesse!").greet();

    let mut my_stack = Stack::new();
    my_stack.push(Greeter::new("Hello"));
    my_stack.push(Greeter::new("Beautiful"));
    my_stack.push(Greeter::new("World"));

    for greeter in my_stack {
        greeter.greet();
    }

    // BST

    let mut bst = BinarySearchTree::new();
    bst.insert(1);
    bst.insert(2);
    bst.insert(3);

    println!("{:?}", bst);

    bst.insert(0);
    println!("{:?}", bst);
    println!("find result: {:?}", bst.find(0));
}
